const open = require('opn');
const readfile = require('read-file');
const input = require('readline-sync');
const axios = require('axios')

const println = s => process.stdout.write(s + "\n");
const logo = readfile.sync('logo.ascii','utf-8');
const mafalda = readfile.sync('mafalda.ascii','utf-8');

const split = (str, size) => !str ? [] : [].concat(str.slice(0, size)).concat(split(str.slice(size), size))
const sleep = time => new Promise( res => setTimeout(res, time) )
const linebreak = _ => println('')
const serialize = obj => split(Buffer.from(JSON.stringify(obj)).toString('base64'),40).join('\n')

const display = async () => {
    println(logo)
    println('Hola! :wave:')
    
    await sleep(1000)

    linebreak()
    const sentido = input.question('¿Cuál es el sentido de la vida?\n')

    linebreak()
    println('mmmhhh...')
    await sleep(1000)

    println('¡Increíble! En Acámica creemos en lo mismo ;)')
    await sleep(1500)

    linebreak()
    const poder = input.question('Si tuvieras un super poder, ¿Cuál sería? (no vale la invisibilidad)\n')

    linebreak()
    const razon = input.question('¿Por qué?')

    println('Nada mal, nada mal...')
    await sleep(1000)

    linebreak()
    const modulo = input.keyInSelect(['NODECONF', 'TWITTER', 'FACEBOOK', 'MEDIA-QUERY'], '¿Cómo llegaste a instalar este módulo?\n', {cancel: 'ME LO CONTÓ MAFALDA'})

    linebreak()
    const acamica = input.keyInYNStrict('Conocés Acámica?\n')
    if (acamica) {
        println('Eso nos pone muy contentos. Significa que estamos haciendo bien el trabajo.\n')
    } else {
        println('Somos una academia de tecnología centrada en los recursos más importantes: las personas. La Experiencia Acámica es personalizada, práctica y en colaboración con las empresas líderes y los referentes de la comunidad como vos.')
    }

    linebreak()
    const mentor = input.keyInYNStrict('Te gustaría ser parte del equipo de mentores?')
    
    linebreak()
    const personal = {}

    if (!mentor) {
        println('¡Qué pena! Si algún día cambiás de parecer mandanos un mail a mentores+npm@acamica.com')
    } else {
        println('Dejanos tu mail y nombre y nos ponemos en contacto para conocerte.')
        linebreak()
        personal.email = input.question('Email: ')
        linebreak()
        personal.nombre = input.question('Nombre: ')
    }

    const data = {sentido, acamica, modulo, personal, poder, razon}
    try {
        await axios.post('https://ms.testing-stage.acamica.net/marketing/mentorship', data)
        println(mafalda)

        linebreak()
	    println("Por una comunidad más grande #InstallMentorship")
    } catch ({message: error}) {
        println('Hubo un problema intentando llevar los acami-datos a la acami-guarida. Tenés internet?')
        println('No dudes en escribirnos a mentores+npm@acamica.com y si preguntan, podes mostrar esto:')
        println('-----------------------')
        println( serialize({data, error}) )
        println('-----------------------')
    }
    
    await sleep(1000)
}

display()

